> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/finpay-pg/snap/qris-tap-aggregator/cpm-tap-payment.md).

# CPM/TAP Payment

QRIS TAP Double (Multi-Acquirer)

#### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

| Environment | Method | URL |
| ----------- | ------ | --- |
| Development | POST   | TBC |
| Production  | POST   | TBC |

#### Body Request <a href="#body-request" id="body-request"></a>

| No | Name                           | Type              | Mandatory | Min Length | Max Length | Description                                                                                                                                                  |
| -- | ------------------------------ | ----------------- | --------- | ---------- | ---------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| 1  | partnerReferenceNo             | String            | M         | 1          | 64         | Transaction identifier on service consumer system                                                                                                            |
| 2  | qrContent                      | String            | M         | 1          | 512        | QR String CPM                                                                                                                                                |
| 3  | amount                         | Object            | M         |            |            |                                                                                                                                                              |
| 4  | value                          | String (ISO4217)  | M         | 1          | 64         | Transaction Amount Example : IDR 10.000,- will be placed with 10000.00                                                                                       |
| 5  | currency                       | String            | M         | 1          | 3          | Currency = IDR                                                                                                                                               |
| 6  | feeAmount                      | Object            | O         |            |            |                                                                                                                                                              |
| 7  | value                          | String (ISO4217)  | O         | 1          | 18         | Transaction Amount Example : IDR 10.000,- will be placed with 10000.00                                                                                       |
| 8  | currency                       | String            | O         | 1          | 3          | Currency = IDR                                                                                                                                               |
| 9  | merchantId                     | String            | M         | 1          | 64         | Merchant identifier that is unique per each merchant.                                                                                                        |
| 10 | title                          | String            | M         | 1          | 256        | Description                                                                                                                                                  |
| 11 | merchantName                   | String            | M         | 1          | 64         | Merchant Name                                                                                                                                                |
| 12 | terminalId                     | String            | O         | 1          | 32         | Terminal identification                                                                                                                                      |
| 13 | expiryTime                     | String (ISO 8601) | O         | 25         | 25         | <p>Format expiryTime menggunakan standar ISO 8601:</p><p>YYYY-MM-DDThh<span data-gb-custom-inline data-tag="emoji" data-code="1f1f2-1f1f2">🇲🇲</span>ss</p> |
| 14 | additionalInfo                 | Object            | M         |            |            |                                                                                                                                                              |
| 15 | additionalInfo.transactionType | String            | M         | 1          | 32         | <p>To identify the transaction method:<br>TAPIN(Tap In), TAPOUT(Tap out)</p>                                                                                 |

**Sample Request**

```
{
  "partnerReferenceNo": "2020102900000000000001",
  "qrContent": "hduvY...",
  "amount": {
    "value": "12345678.00",
    "currency": "IDR"
  },
  "feeAmount": {
    "value": "12345678.00",
    "currency": "IDR"
  },
  "merchantId": "00007100010926",
  "title": "example",
  "merchantName": "Mer0012",
  "terminalId": "213141251124",
  "expiryTime": "2020-12-21T17:21:41+07:00",
  "additionalInfo": {
    " TransactionType ": "TAPIN|TAPOUT"
  }
}    
```

#### Body Response <a href="#body-response" id="body-response"></a>

| No | Name                                   | Type              | Mandatory | Min Length | Max Length | Description                                        |
| -- | -------------------------------------- | ----------------- | --------- | ---------- | ---------- | -------------------------------------------------- |
| 1  | responseCode                           | Enum              | M         | 1          | 7          | BI SNAP response code.                             |
| 2  | responseMessage                        | String            | M         | 1          | 150        | BI SNAP response message.                          |
| 3  | referenceNo                            | String            | M         | 1          | 64         | Transaction identifier on service provider system. |
| 4  | partnerReferenceNo                     | String            | O         | 1          | 64         | Transaction identifier on service consumer system. |
| 5  | transactionDate                        | String (ISO 8601) | O         | 25         | 25         | Transaction date and time.                         |
| 6  | additionalInfo                         | Object            | O         |            |            | Additional transaction details.                    |
| 7  | additionalInfo.latestTransactionStatus | String            | O         | 2          | 2          | Latest transaction status. `00` means success.     |
| 8  | additionalInfo.transactionStatusDesc   | String            | O         | 1          | 50         | Transaction status description.                    |
| 9  | additionalInfo.merchantPAN             | String            | O         | 1          | 19         | Merchant PAN.                                      |
| 10 | additionalInfo.customerPAN             | String            | O         | 1          | 19         | Customer PAN.                                      |
| 11 | additionalInfo.issuerName              | String            | O         | 1          | 26         | Issuer name.                                       |
| 12 | additionalInfo.acquirerID              | String            | O         | 1          | 8          | Acquirer institution number.                       |

**Sample Response**

```
{
  "responseCode": "2006100",
  "responseMessage": "Request has been processed successfully",
  "referenceNo": "2020102977770000000009",
  "partnerReferenceNo": "2020102900000000000001",
  "transactionDate": "2020-12-23T07:54:11+07:00",
  "additionalInfo": {
    "latestTransactionStatus": "00",
    "transactionStatusDesc": "success",
    "merchantPAN": "9360000801000237321",
    "customerPAN": "9360000812138965527",
    "issuerName": "Mandiri",
    "acquirerID": "93600008"
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.finpay.id/finpay-pg/snap/qris-tap-aggregator/cpm-tap-payment.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
